#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct mesto
{
	char naziv[50];
	int udaljenost;
	char okretnica[5];
	struct mesto *levi, *desni;
} mesto;

#define novi(x) x = (mesto*)malloc(sizeof(mesto))

mesto* form()
{
	mesto *p = NULL, *temp, *pom;
	int i, n; char c[50], o[5];
	
	printf("Unesite broj mesta.\n");
	scanf("%d", &n);
	getchar();
	
	for(i = 0; i < n; i++)
	{
		novi(temp);
		printf("Unesite ime mesta.\n");
		gets(c);
		strcpy(temp->naziv, c);
		printf("Unesite udaljenost.\n");
		scanf("%d", &temp->udaljenost);
		getchar();
		printf("Unesite DA ili NE (okretnica).\n");
		gets(o);
		strcpy(temp->okretnica, o);
		temp->levi = temp->desni = NULL;
		
		if(p == NULL)
			p = temp;
		else
		{
			pom = p;
			while(pom->desni)
				pom = pom->desni;
				
			pom->desni = temp;
			temp->levi = pom;
		}
	}
	
	return p;
}

int put(char *k, char *m, mesto *p)
{
	int put = 0, ind = 0;
	
	while((p->desni) && (strcmp(m, p->naziv) != 0))
	{
		if(strcmp(p->naziv, k) == 0)
			ind = 1;
		p = p->desni;
	}
	put = p->udaljenost;
	
	if(ind == 1)
	{
		while(strcmp(p->okretnica, "DA") != 0)
			p = p->desni;
		put = p->udaljenost;
		
		while(strcmp(p->naziv, k) != 0)
			p = p->levi;
			
		put += put - p->udaljenost;
	}
	else
	{
		while(strcmp(p->naziv, k) != 0)
			p = p->desni;
		put = p->udaljenost;
	}
	
	return put;
}

void print(mesto *p)
{
	while(p)
	{
		printf("%s %d %s\n", p->naziv, p->udaljenost, p->okretnica);
		p = p->desni;
	}
}

main()
{
	mesto *p;
	char m[50], k[50];
	int pr;
	
	p = form();
	print(p);
	
	printf("Unesite M i K.\n");
	gets(m);
	gets(k);
	
	pr = put(k, m, p);
	printf("Predjeni put: %d\n", pr);
}
