#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct radnik radnik;

struct radnik
{
	char *IME;
	char *TIP_RADA;
	char *KATEGORIJA_RADA;
	int balans;
	radnik *levo,*desno; 
};

radnik *kreiraj()
{
	radnik *temp=(radnik *)malloc(sizeof(radnik));
	return temp;
}

char *kreiraj_string(int n)
{
	char *temp=(char *)malloc((n+1)*sizeof(char));
	return temp;
}

int dubina(radnik *p)
{
	int dd=0,dl=0;
	if(p)
	{
		if(p->levo) dl=dubina(p->levo);
		if(p->desno) dd=dubina(p->desno);
		if(dl>dd) return dl++;
		else return dd++;
	}
	else return 0;
}

void lrotacija(radnik **p)
{
	radnik *poml,*pomd;
	
	poml=(*p);
	pomd=poml->desno;
	poml->desno=pomd->levo;
	pomd->levo=poml;
	(*p)=pomd;
	
	poml->balans=dubina(poml->desno)-dubina(poml->levo);
	pomd->balans=dubina(pomd->desno)-dubina(pomd->levo);
}

void drotacija(radnik **p)
{
	radnik *poml,*pomd;
	
	pomd=(*p);
	poml=pomd->levo;
	pomd->levo=poml->desno;
	poml->desno=pomd;
	(*p)=poml;
	
	poml->balans=dubina(poml->desno)-dubina(poml->levo);
	pomd->balans=dubina(pomd->desno)-dubina(pomd->levo);
}

void unos(radnik **p)
{
	radnik *temp=NULL,*pom=NULL;
	char s[50],b[50];
	temp=(*p);
	int i,n;
	printf("uneti n:\n");
	scanf("%d",&n);
	getchar();
	for (i=0;i<n;i++)
	{
		temp=kreiraj();
		printf("uneti ime:\n");
		gets(s);
		temp->IME=kreiraj_string(strlen(s));
		strcpy(temp->IME,s);
		printf("uneti tip rada:\n");
		gets(b);
		temp->TIP_RADA=kreiraj_string(strlen(b));
		strcpy(temp->TIP_RADA,b);
		if(strcmp(temp->TIP_RADA,"rad")==0)
		{
			printf("uneti kategoriju rada:\n");
			gets(s);
			temp->KATEGORIJA_RADA=kreiraj_string(strlen(s));
			strcpy(temp->KATEGORIJA_RADA,s);
		}
		printf("nema");
		temp->levo=temp->desno=NULL;
		dodaj(&p,temp);
	}
	(*p)=temp;
}

int dodaj(radnik **p,radnik *temp)
{
	int rez=0,inkrement;
	radnik *pom=(*p);
	if(pom==NULL)
	{
		pom=temp;
		pom->balans=0;
		rez=1;
	}
	else
	{
		if(vrati(pom)>vrati(temp)) inkrement=-dodaj(&(pom->levo),temp);
		else inkrement=dodaj(&(pom->desno),temp);
		
		pom->balans=pom->balans+inkrement;
		
		if((pom->balans!=0) && (inkrement!=0))
		{
			if (pom->balans<-1)
			{
				if(pom->levo->balans<0) drotacija(&pom);
				else
				{
					lrotacija(&(pom->levo));
					drotacija(&pom);
				}
			}
			else if(pom->balans>1)
			{
				if(pom->desno->balans>0) lrotacija(&pom);
				else
				{
					drotacija(&(pom->desno));
					lrotacija(&pom);
				}
			}
			else rez=1;
		}
	}
	(*p)=pom;
	return rez;
}

int vrati(radnik *p)
{
	int suma=0;
	if(strcmp(p->KATEGORIJA_RADA,"M21")==0) suma=4;
	if(strcmp(p->TIP_RADA,"monografija")==0) suma=3;
	if(strcmp(p->KATEGORIJA_RADA,"M22")==0) suma=2;
	printf("suma",suma);
	return suma;	
}

void ispis(radnik *p)
{
	if(p)
	{
		if(p->desno) ispis(p->desno);
		printf("%s %s %s\n",p->IME,p->TIP_RADA,p->KATEGORIJA_RADA);
		if(p->levo) ispis(p->levo);
	}
}

main()
{
	radnik *radi=NULL;
	unos(&radi);
	ispis(radi);
	
	
}


