#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct naucnik
{
	char ime[30];
	char tip_rada[30];
	char kategorija_rada[30];
	int balans;
	int vred;
	struct naucnik *levi,*desni;
}naucnik;

#define novi(x) x = (naucnik *)malloc(sizeof(naucnik))

int dodaj(naucnik **, char [20], char [20]);
naucnik *form();
void lrotacija(naucnik**);
void drotacija(naucnik**);
int dubina(naucnik*);
void ispis(naucnik*);


int vrednost(naucnik *p)
{
	if(!strcmp(p->tip_rada,"rad"))
	{
		if(!strcmp(p->kategorija_rada,"M21")) return 1;
		else if(!strcmp(p->kategorija_rada,"M22")) return 3;
	}
	if(!strcmp(p->tip_rada,"monografija")) return 2;
	else return 4;
}

int dodaj(naucnik **p, char im[20], char tip[20])
{
	int inkrement, rezultat;
	naucnik *pom,*pos,*temp;
	pom = *p;
	novi(temp);
	strcpy(temp->ime,im);
	strcpy(temp->tip_rada,tip);
	if(!strcmp(temp->tip_rada,"rad"))
	{
		printf("unesite kategoriju rada:\n");
		scanf("%s",temp->kategorija_rada);
	}
	temp->vred = vrednost(temp);
	temp->balans = 0;
	rezultat = 1;
	
	if(pom==NULL)
		pom = temp;
	
	
	else
	{
		pos = pom;
		if(temp->vred >= pos->vred) inkrement = dodaj(&(pos->desni),im,tip);
		else inkrement = -dodaj(&(pos->levi),im,tip);
		temp->balans +=inkrement;
		
		if(inkrement !=0 && temp->balans!=0)
		{
			if(temp->balans < -1)
			{
				if(temp->levi->balans < 0) drotacija(&temp);
				else
				{
					lrotacija(&(temp->levi));
					drotacija(&temp);
				}
			}
			else
			if(temp->balans > 1)
			{
				if(temp->desni->balans > 0) lrotacija(&temp);
				else
				{
					drotacija(&(temp->desni));
					lrotacija(&temp);
				}
			}
			else rezultat = 0;
		}
	*p = pom;
	return rezultat;
	}
	
}

void lrotacija(naucnik **p)
{
	naucnik *pom1, *pomd;
	pom1 = *p;
	pomd = pom1->desni;
	pom1->desni = pomd->levi;
	pomd->levi = pom1;
	*p = pomd;
	
	pom1->balans = dubina(pom1->desni) - dubina(pom1->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(naucnik **p)
{
	naucnik *pom1, *pomd;
	pomd = *p;
	pom1 = pomd->levi;
	pomd->levi = pom1->desni;
	pom1->desni = pomd;
	*p = pom1;
	
	pom1->balans = dubina(pom1->desni) - dubina(pom1->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int dubina(naucnik *p)
{
	int dd = 0, dl = 0;
	if(p)
	{
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if(dl > dd) return ++dl;
		else return ++dd;
	}
	return 0;
}

naucnik *form()
{
	naucnik *koren = NULL;
	char im[20];
	char tip[20];
	int n,i,c;
	scanf("%d",&n);
	for(i = 0; i < n; i++)
	{
		printf("unesite ime naucnika:\n");
		c = fgetc(stdin);
		fgets(im,20,stdin);
		printf("unesite tip rada:\n");
		//c = fgetc(stdin);
		fgets(tip,20,stdin);
		dodaj(&koren,im,tip);
	}
	return koren;
}

void ispis(naucnik *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s %s %s\n",p->ime,p->tip_rada,p->kategorija_rada);
		ispis(p->desni);
	}
}


	
main()
{
	naucnik *p;
	p = form();
	ispis(p);
}

