#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct team
{
	char name[20];
	char game[20];
	int num;
	struct team *next;
} team;

typedef struct game
{
	char name[20];
	int num;
	struct game *next;
} game;

#define new(x) x = (team *)malloc(sizeof(team))
#define newg(x) x = (game *)malloc(sizeof(game))

void add(team **p, char *n, char *i, int k)
{
	team *pom, *tmp;

	new(tmp);
	strcpy(tmp->name, n);
	strcpy(tmp->game, i);
	tmp->num = k;
	tmp->next = NULL;

	if(!(*p)) *p = tmp;
	else
	{
		pom = *p;
		while(pom->next) pom = pom->next;
		pom->next = tmp;
	}
}

team* form()
{
	int k, l;
	team *p = NULL;
	char n[20], i[20];

	scanf("%d", &l);
	getchar();

	while(l)
	{
		gets(n);
		gets(i);
		scanf("%d", &k);
		getchar();
		if(k <= 5)
		{
			add(&p, n, i, k);
			l--;
		}
	}

	return p;
}

void print(team *p)
{
	if(p)
	while(p)
	{
		printf("Ime tima %s, naziv igre %s, broj igraca %d.\n", p->name, p->game, p->num);
		p = p->next; 
	}
	else printf("Lista je prazna.\n");
}

void addg(game **p, char n[20], int k)
{
	game *pom, *tmp;

	newg(tmp);
	strcpy(tmp->name, n);
	tmp->num = k;
	tmp->next = NULL;

	if(!(*p)) *p = tmp;
	else
	{
		pom = *p;
		while(pom->next) pom = pom->next;
		pom->next = tmp;
	}
}

game* formn(team *p)
{
	team *pom;
	game *q = NULL;
	char n[20];
	int k = 0;

	while(p)
	{
		strcpy(n, p->game);
		pom = p;
		if(p->num > 0)
		{
			while(pom)
			{
				if(!strcmp(pom->game, n))
				{
					k += pom->num;
					pom->num *= -1;
				}
				pom = pom->next;
			}
			addg(&q, n, k);
		}
		k = 0;
		p = p->next;
	}
	return q;
}

void printG(game *p)
{
	while(p)
	{
		printf("Igra %s igraca %d\n", p->name, p->num);
		p = p->next;
	}
}

void delete(team **p, game *q)
{
	team *pom, *taj, *pre, *pom1;
	game *pomg;
	char n[20];

	pom = *p;
	pomg = q;
	strcpy(n, pom->game);
	while(pomg)
	{
		if(!strcmp(pomg->name, n) && (pomg->num < 10))
		{
			pom1 = *p;
			pre = NULL;
			taj = pom1;

			while(pom1)
			{
				if(!strcmp(pom1->game, n))
				{
					if(!pre)
					{
						*p = taj->next;
						free(taj);
						taj = *p;
						pom = *p;
					}
					else
					{
						if(!taj->next)
						{
							free(taj);
						}
						else
						{
							pre->next = taj->next;
							free(taj);
							taj = pre->next;
						}
					}
				}
				pre = pom1;
				pom1 = pom1->next;
				taj = pom1;
			}
		}
		pomg = pomg->next;
		pom = pom->next;
		strcpy(n, pom->game);
	}
}

team* fix(team *p)
{
	team *pom;
	pom = p;

	while(pom)
	{
		pom->num *= -1;
		pom = pom->next;
	}
	return p;
}

main(int argc, char* argv[])
{

	team *p;
	game *q;

	p = form();
	print(p);

	q = formn(p);
	printG(q);

	p = fix(p);
	delete(&p, q);
	print(p);
}
