#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define novi(x) x=(drvo*)malloc(sizeof(drvo))

enum{CRVENA,CRNA};

typedef struct drvo {
	char ime[30];
	char TIP_RADA[20];
	char KATEGORIJA_RADA[5];
	int boja;
	struct drvo *levi, *desni, *roditelj; 
	}drvo;
	
void ispis (drvo *p) {
	if (p) {
		ispis(p->desni);
		printf("%s %s ",p->ime,p->TIP_RADA);
		if (!strcmp(p->TIP_RADA,"rad")) printf("%s ",p->KATEGORIJA_RADA);
		if (p->boja==CRVENA) printf("(CRVENA)\n");
		else printf("(CRNA)\n");
		ispis(p->levi);
	}
}

void lrotacija (drvo **t) {
	drvo *x, *y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	if (y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if (x==x->roditelj->levi) x->roditelj->levi=y;
	else x->roditelj->desni=y;
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija (drvo **t) {
	drvo *x, *y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	if (x->desni) x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	if (y==y->roditelj->levi) y->roditelj->levi=x;
	else y->roditelj->desni=x;
	x->desni=y;
	y->roditelj=x;
	*t=x;
}

int tip (drvo *z) {
	if ((!strcmp(z->TIP_RADA,"rad"))&&(!strcmp(z->KATEGORIJA_RADA,"M21"))) return 3;
	if (!strcmp(z->TIP_RADA,"monografija")) return 2;
	if ((!strcmp(z->TIP_RADA,"rad"))&&(!strcmp(z->KATEGORIJA_RADA,"M22"))) return 1;
	return 0;
}
	



void bojefix (drvo **p, drvo *z) {
	drvo *y,*t;
	while((z->roditelj)&&(z->roditelj->boja==CRVENA)) {
		if (z->roditelj==z->roditelj->roditelj->levi) {
				y=z->roditelj->roditelj->desni;
				if ((y)&&(y->boja==CRVENA)) {
								z->roditelj->boja=CRNA;
								y->boja=CRNA;
								z->roditelj->roditelj->boja=CRVENA;
								z=z->roditelj->roditelj;
							}
				else {
						if (z==z->roditelj->desni) {
											z=z->roditelj;
											lrotacija(&z);
											if (!z->roditelj) *p=z;
											z=z->levi;
										}
						z->roditelj->boja=CRNA;
						z->roditelj->roditelj->boja=CRVENA;
						t=z->roditelj->roditelj;
						drotacija(&t);
						if (!t->roditelj) *p=t;
					}
				}
		else {
				y=z->roditelj->roditelj->levi;
					if ((y)&&(y->boja==CRVENA)) {
										z->roditelj->boja=CRNA;
										y->boja=CRNA;
										z->roditelj->roditelj->boja=CRVENA;
										z=z->roditelj->roditelj;
									}
					else {
							if (z==z->roditelj->levi) {
												z=z->roditelj;
												drotacija(&z);
												if (!z->roditelj) *p=z;
												z=z->desni;
											}
							z->roditelj->boja=CRNA;
							z->roditelj->roditelj->boja=CRVENA;
							t=z->roditelj->roditelj;
							lrotacija(&z);
							if (!z->roditelj) *p=t;
						}
					}
				}
		(*p)->boja=CRNA;
	}
	
void dodaj(drvo **p, drvo *z) {
	drvo *x, *y;
	x=*p;
	y=NULL;
	while(x) {	
				y=x;
				if (tip(z)<tip(x)) x=x->levi;
				else x=x->desni;
			}
	z->roditelj=y;
	if (!y) *p=z;
	else {
			if (tip(z)<tip(y)) y->levi=z;
			else y->desni=z;
		}
bojefix(p,z);
}

drvo* form() {
	drvo *cvor,*koren;
	int n;
	char s[30];
	koren=NULL;
	scanf("%d",&n);
	while (n) {
				getchar();
				novi(cvor);
				gets(s);
				strcpy(cvor->ime,s);
				scanf("%s",cvor->TIP_RADA);
				if (!strcmp(cvor->TIP_RADA,"rad")) scanf("%s",cvor->KATEGORIJA_RADA);
				cvor->boja=CRVENA;
				cvor->levi=NULL;
				cvor->desni=NULL;
				dodaj(&koren,cvor);
				n--;
			}
	return koren; }
	
	

void brisi(drvo **p, drvo *q) {
	drvo *cvor;
		if (q)
			if (tip(q)>0) {
							
							novi(cvor);
							strcpy(cvor->ime,q->ime);
							strcpy(cvor->TIP_RADA,q->TIP_RADA);
							strcpy(cvor->KATEGORIJA_RADA,q->KATEGORIJA_RADA);
							cvor->levi=NULL;
							cvor->desni=NULL;
							cvor->roditelj=NULL;
							cvor->boja=CRVENA;
							dodaj(p,cvor);
							brisi(p,q->levi);
							brisi(p,q->desni);
						}
			else {		
					brisi(p,q->levi);
					brisi(p,q->desni);
						}
		else return; 
		}
		
void vise(drvo *p) {
	int x=0,y=0;
	if (p) {
			if (!strcmp(p->TIP_RADA,"monografija")) x++;
			if ((!strcmp(p->TIP_RADA,"rad"))&&(!strcmp(p->KATEGORIJA_RADA,"M21"))) y++;
			vise(p->levi);
			vise(p->desni);
		}
	else if (x>y) printf("X\n");
	     else if (x==y) printf("ISTO\n");
	     else printf("Y\n");
}
		
main() {
	drvo *p,*b;
	p=NULL;
	b=NULL;
	p=form();
	ispis(p);
	brisi(&b,p);
	ispis(b);
	vise(p);
	printf("Napomena: samo se gleda poslednji ispis funkcije vise\n");
}
				
				
	

