#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct avl 
{
	char ime[50],tiprada[30],kat_rada[10];
	int balans;
	struct avl *levi,*desni;
};

#define novi(x) x=(struct avl*)malloc(sizeof(struct avl))
int br(char *tr,char *kr)
{
	if(strcmp(kr,"M21")==0) return 3;
	if(strcmp(tr,"monografija")==0) return 2;
	if (strcmp(kr,"M22")==0) return 1;
	else return 0;
}
int br1(struct avl *p)
{
	if(strcmp(p->kat_rada,"M21")==0) return 3;
	if(strcmp(p->tiprada,"monografija")==0) return 2;
	if (strcmp(p->kat_rada,"M22")==0) return 1;
	else return 0;
	
	
}
		





int dubina(struct avl*p)
{
	int dd=0,dl=0;
	if (p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return dd++;
		else return dl++;
	}
}

void lrotacija(struct avl **p)
{
	struct avl *poml,*pomd;
	
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->desni);
}

void drotacija(struct avl **p)
{
	struct avl *poml,*pomd;
	
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->desni);
}
	

		
	
int dodaj(struct avl **p,char *i,char *tr,char *kr)
{
	struct avl *t=*p;
	int rez,ink;
	
	if(t==NULL)
	{
		novi(t);
		strcpy(t->ime,i);
		strcpy(t->tiprada,tr);
		strcpy(t->kat_rada,kr);
		t->levi=t->desni=NULL;
		t->balans=0;
		rez=1;
		
	}
	else
	{ 

		if(br(tr,kr)<=br1(t)) ink=dodaj(&(t->desni),i,tr,kr);
		else ink=-dodaj(&(t->levi),i,tr,kr);
		
		t->balans+=ink;
		
		if(ink!=0 && t->balans!=0)
		{
			if(t->balans<-1)
			{
				if(t->levi->balans<0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rez=1;
		}
		
	}
*p=t;
return rez;
	
}

struct avl *form()
{
	struct avl *p=NULL;
	int n,ii;
	char i[50],tr[30],kr[10];
	
	printf("Unesi N\n");
	scanf("%d",&n);
	
	for(ii=0;ii<n;ii++)
	{
		printf("unesi ime naucnika\n");
		getchar();
		gets(i);
		printf("tipa rada\n");
		scanf("%s",tr);
		if(strcmp(tr,"rad")==0)
		{
			printf("unesi kategorija rada\n");
			scanf("%s",kr);
		}
		else (strcpy(kr,"\0"));
		dodaj(&p,i,tr,kr);
	}
	return p;
}

void ispis(struct avl *p)
{
	if(p)
	{
		//if(p->levi) 
		ispis(p->levi);
		printf("%s\t %s\t %s\n",p->ime,p->tiprada,p->kat_rada);
		//if(p->desni) 
		ispis(p->desni);
	}
}
	/*
void vise(struct avl *p)
{
	int m=0,mo=0;
	vise(p->levi);
	if(strcmp(p->tiprada,"monografija")==0) mo++;
	else if(strcmp(p->tiprada,"rad")==0)
			if(strcmp(p->kat_rada,"M21")==0) m++;
			
			vise(p->desni);
			if(mo>m) printf("Vise monografija");
			else printf("Vise M21");
		}*/
void brisi(struct avl **q,struct avl *p)
{
	if(p)
	{
		brisi(q,p->levi);
		if(strcmp(p->tiprada,"nema")!=0)
		dodaj(q,p->ime,p->tiprada,p->kat_rada);
		brisi(q,p->desni);
	
}
}
	


main()
{
	struct avl *p,*q=NULL;
	p=form();
	ispis(p);
	//vise(p);
	
	brisi(&q,p);
	printf("\nposle brisanja\n");
	ispis(q);
}
