#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct cvor cvor;

struct cvor {
	int balans;
	char *ime;
	char *tip_rada;
	char *kategorija;
	cvor *levi,*desni;
};

cvor *alociraj()
{
		cvor *temp=(cvor *)malloc(sizeof(cvor));
		return temp;
}

char *kreiraj_string(int n)
{
		char *temp=(char *)malloc(sizeof(char)*(n+1));
		return temp;
}

int dubina(cvor *p)
{
		int dd=0,dl=0;
		
		if(p)
		{
			if(p->levi) dl=dubina(p->levi);
			if(p->desni) dd=dubina(p->desni);
			if(dl>dd) return dl++;
			else return dd++;
		}
		else return 0;
}

void lrotacija(cvor **p)
{
		cvor *poml,*pomd;
		
		poml=(*p);
		pomd=poml->desni;
		poml->desni=pomd->levi;
		pomd->levi=poml;
		(*p)=pomd;
		
		poml->balans=dubina(poml->desni)-dubina(poml->levi);
		pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(cvor **p)
{
		cvor *poml,*pomd;
		
		pomd=(*p);
		poml=pomd->levi;
		pomd->levi=poml->desni;
		poml->desni=pomd;
		(*p)=poml;
		
		poml->balans=dubina(poml->desni)-dubina(poml->levi);
		pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int funk(cvor *p)
{
		if(strcmp(p->kategorija,"m21")==0) return 3;
		if(strcmp(p->kategorija,"m22")==0) return 1;
		if(strcmp(p->tip_rada,"monografija")==0) return 2;
		return 0;
}

void ucitavanje(cvor **p)
{
		cvor *pom=(*p),*temp;
		char ime[50],tipr[20],mm[5];
		int n,i;
		scanf("%d",&n);
		getchar();
		for (i = 0; i < n; i++)
		{
			temp=alociraj();
			temp->levi=temp->desni=NULL;
			gets(ime);
			printf("%s\n",ime);
			//getchar();
			gets(tipr);
			printf("%s\n",tipr);
			//getchar();
			if(strcmp(tipr,"rad")==0)
			{
					gets(mm);
					
					printf("%s\n",mm);
					//getchar();
					temp->kategorija=kreiraj_string(strlen(mm));
					strcpy(temp->kategorija,mm);
			}
			
			temp->ime=kreiraj_string(strlen(ime));
			strcpy(temp->ime,ime);
			temp->tip_rada=kreiraj_string(strlen(tipr));
			strcpy(temp->tip_rada,tipr);
			
			
			dodaj(&pom,temp);
			
				
		}
		(*p)=pom;
		
}


int dodaj(cvor **p,cvor *temp)
{
		int rez=0,inkrement;
		
		cvor *pom=(*p);
		
		if(pom==NULL)
		{
			pom=temp;
			pom->balans=0;
			rez=1;
		}
		else
		{
			if(funk(pom)>funk(temp)) inkrement=-dodaj(&(pom->levi),temp);
			else inkrement=dodaj(&(pom->desni),temp);
			
			pom->balans=pom->balans+inkrement;
			
			if((pom->balans!=0) && (inkrement!=0))
			{
					if(pom->balans<-1)
					{
						if(pom->levi->balans<0) drotacija(&(pom));
						{
								lrotacija(&(pom->levi));
								drotacija(&(pom));
						}
					}
					if(pom->balans>1)
					{
							if(pom->desni->balans>0) lrotacija(&(pom));
						{
								drotacija(&(pom->desni));
								lrotacija(&(pom));
						}
					}
					else 
					{
							rez=1;
					}
			}
		}
		(*p)=pom;
		return rez;
}


void ispis(cvor *p)
{
		if(p)
		{
				if(p->desni) ispis(p->desni);
				printf("%s\t%d",p->tip_rada,p->balans);
				if(p->levi) ispis(p->levi);
				
		}
}

void brisanje(cvor *p,cvor **q)
{
		if(p)
		{
			if(p->levi) brisanje(p->levi,&(*q));
			if(p->desni) brisanje(p->desni,&(*q));
			
			if(strcmp(p->tip_rada,"nema")!=0)
			{
					cvor *nov;
					nov=p;
					nov->levi=nov->desni=NULL;
					dodaj(&(*q),nov);
			}
		}
}


void brojanje(cvor *p)
{	
	static int mon=0,nr=0;
		if(p)
		{
			if(p->levi) brojanje(p->levi);
			if(p->desni) brojanje(p->desni);
			
			if(strcmp(p->tip_rada,"monografija")==0) mon++;
			if(strcmp(p->kategorija,"m21")==0) nr++;
			
		}
		
		if(mon>nr) printf("Vise monografija\n");
		
		if(mon==nr) printf("IMA ISTO\n");
		
		if(mon<nr) printf("Vise naucnih radova m21\n");
}

/*
int brojanjeM(cvor *p)
{	
	static int mon=0;
		if(p)
		{
			if(p->levi) mon=brojanje(p->levi);
			if(p->desni) mon=brojanje(p->desni);
			
			if(strcmp(p->tip_rada,"monografija")==0) mon++;
			
			
		}
		
		return mon;
}


int brojanjeN(cvor *p)
{	
	static int non=0;
		if(p)
		{
			if(p->levi) non=brojanje(p->levi);
			if(p->desni) non=brojanje(p->desni);
			
			if(strcmp(p->kategorija,"m21")==0) non++;
			
			
		}
		
		return non;
}*/

main()
{
		cvor *radi=NULL;
		
		ucitavanje(&radi);
		
		ispis(radi);
}
