#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista 
{
	char *naziv_ekipe;
	char *igra;
	int br_igraca;
	struct lista *sledeci;
}lista;

typedef struct broj
{
	char sport[50];
	int broji;
	struct broj *sledeci;
}broj;

#define novi(x) x = (lista *)malloc(sizeof(lista))
#define nova(x) x = (broj *)malloc(sizeof(broj))
#define nov(x,y) x = (char *)malloc(strlen(y) + 1)

void dodaj(lista **p, char *s, char *c, int t)
{
	lista *temp,*res,*pos;
	char k[50];
	
	novi(temp);
	if(!temp)
	{
		printf("Greska pri alokaciji memorije\n");
		exit(0);
	}
	
	temp->br_igraca = t;
	temp->naziv_ekipe = (char *)malloc(strlen(s) + 1);
	strcpy(temp->naziv_ekipe, s);
	temp->igra  = (char *)malloc(strlen(c) + 1);
	strcpy(temp->igra, c);
	temp->sledeci = NULL;
	
	res = *p;
	
	if(!res)   res = temp;
	else 
	{
		pos = res;
		while(pos->sledeci) pos = pos->sledeci;
		pos->sledeci = temp;
	}
	
	*p = res;
}


lista *form_lista(int k)
{
	lista *p;
	p = NULL;
	
	int i = 0, t;
	char s[50], c[50];

		
	while(i < k)
	{
		printf("Unesite ime ekipe:\n");
		scanf("%s", s);
		printf("Uneste ime igre:\n");
		scanf("%s", c);
		printf("Unesite broj igraca:\n");
		scanf("%d", &t);
		printf("\n");
		
		if(t <= 5)
		{
			dodaj(&p,s,c,t);
			i++;
		}
		
	}
	
	return p;
}

void ispis(lista *p)
{	
	while(p != NULL)
	{
		printf("Ime ekipe:%s\nIme igre:%s\nBroj igraca:%d\n\n",p->naziv_ekipe,p->igra,p->br_igraca);
		p = p->sledeci;
	}
}

void ispisa(lista *p, int k)
{	
	int i = 1;
	while(i < k)
	{
		printf("Ime ekipe:%s\nIme igre:%s\nBroj igraca:%d\n\n",p->naziv_ekipe,p->igra,p->br_igraca);
		p = p->sledeci;
		i++;
	}
}

void brisi(lista **p, char *s)
{
	lista *temp, *res, *pos;
	
	res = *p; 
	pos = res;
	
	while(!strcmp(pos->igra, s))
	{
		res = pos->sledeci;
		free(pos);
		pos = res;
	}
	
	while(pos->sledeci)
	if(!strcmp(pos->sledeci->igra, s))
	{
		temp = pos->sledeci;
		pos->sledeci = temp->sledeci;
		free(temp);
	}
	
	*p = res;
}

void broji_sportove(lista *p, broj **q)
{
	lista *pom1, *pom2;
	broj *temp, *res, *pos;
	int t = 0;
	q = NULL;
	
	
	pom1 = pom2 = p;
	
	while(pom1 != NULL)
	{
		t = 0;
		while(pom2 != NULL)
		if(!strcmp(pom1->igra, pom2->igra))
		{
			t++;
			pom2 = pom2->sledeci;
		}
		pom2 = p;
		nova(temp);
		if(!temp)
		{
			printf("Greska pri alokaciji memorije\n");
			exit(0);
		}
		temp->broji = t;
		strcpy(temp->sport, pom1->igra);
		res = *q;
		if(!res) res = temp;
		else 
		{
			pos = res;
			while(pos->sledeci)
			{
				if(strcmp(pos->sport, temp->sport)) break;
				else pos = pos->sledeci;
			}
			
			pos->sledeci = temp;
		}
		
		*q = res;
		
		pom1 = pom1->sledeci;
	}
}

void ispisq(broj *q)
{
	while(q)
	{
		printf("Ime igre:%s\n, Ukupan broj igraca:%d\n\n",q->sport, q->broji);
		q = q->sledeci;
	}
}
main()
{
	lista *p;
	broj *q;
	int k;
	char s[50];
	printf("Unesite k:\n");
	scanf("%d", &k);
	p = form_lista(k);

	ispis(p);

	broji_sportove(p,&q);
	ispisq(q);
	while(q)
	{
		if(q->broji < 10)
		{
			brisi(&p, q->sport);
		}
		q = q->sledeci;
	}
	ispis(p);
}
