#include <stdio.h>
#include <stdlib.h>
#include <string.h>
enum {CRNA,CRVENA};
struct stablo{
	struct stablo*levi,*desni,*roditelj;
	int boja;
	char*ime,tip_rada[15],kategorija_rada[6];
};
void lrotacija(struct stablo**d){
	struct stablo*poml,*pomd;
	poml=*d;
	pomd=poml->desni;
	if(poml->roditelj){
		if(poml->roditelj->levi==poml)poml->roditelj->levi=pomd;
		else poml->roditelj->desni=pomd;
	}
	if(pomd->levi)pomd->levi->roditelj=poml;
	pomd->roditelj=poml->roditelj;
	poml->roditelj=pomd;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*d=pomd;
}
void drotacija(struct stablo**d){
	struct stablo*poml,*pomd;
	pomd=*d;
	poml=pomd->levi;
	if(pomd->roditelj){
		if(pomd->roditelj->levi==pomd)pomd->roditelj->levi=poml;
		else pomd->roditelj->desni=poml;
	}
	if(poml->desni)poml->desni->roditelj=pomd;
	poml->roditelj=pomd->roditelj;
	pomd->roditelj=poml;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*d=poml;
}
void boje_fix(struct stablo**d,struct stablo*t){
	struct stablo*x,*y;
	while(t->roditelj && t->roditelj->boja==CRVENA){
		if(t->roditelj->roditelj->levi==t->roditelj){
			y=t->roditelj->roditelj->desni;
			if(y && y->boja==CRVENA){
				y->boja=CRNA;
				t->roditelj->boja=CRNA;
				t->roditelj->roditelj->boja=CRVENA;
				t=t->roditelj->roditelj;
			}
			else{
				if(t->roditelj->desni==t){
					t=t->roditelj;
					lrotacija(&t);
					if(!t->roditelj)*d=t;
					t=t->levi;
				}
				t->boja=CRVENA;
				t->roditelj->boja=CRNA;
				t->roditelj->roditelj->boja=CRVENA;
				x=t->roditelj->roditelj;
				drotacija(&x);
				if(!x->roditelj)*d=x;
			}
		}
		else{
			y=t->roditelj->roditelj->levi;
			if(y && y->boja==CRVENA){
				y->boja=CRNA;
				t->roditelj->boja=CRNA;
				t->roditelj->roditelj->boja=CRVENA;
				t=t->roditelj->roditelj;
			}
			else{
				if(t->roditelj->levi==t){
					t=t->roditelj;
					drotacija(&t);
					if(!t->roditelj)*d=t;
					t=t->desni;
				}
				t->boja=CRVENA;
				t->roditelj->boja=CRNA;
				t->roditelj->roditelj->boja=CRVENA;
				x=t->roditelj->roditelj;
				lrotacija(&x);
				if(!x->roditelj)*d=x;
			}
		}
	}
(*d)->boja=CRNA;
}
void dodaj(struct stablo**d,struct stablo*t){
	if(*d==NULL)*d=t;
	else{
		struct stablo*pom1,*pom2=NULL;
		pom1=*d;
		while(pom1){
			pom2=pom1;
			if(vrednost(pom1->tip_rada,pom1->kategorija_rada)>vrednost(t->tip_rada,t->kategorija_rada))pom1=pom1->levi;
			else pom1=pom1->desni;
		}
		if(vrednost(pom2->tip_rada,pom2->kategorija_rada)>vrednost(t->tip_rada,t->kategorija_rada))pom2->levi=t;
		else pom2->desni=t;
		t->roditelj=pom2;
	}
boje_fix(d,t);
}
int vrednost(char*tip_rada,char*kategorija_rada){
	if(strcmp(tip_rada,"nema")){
	if(!strcmp(tip_rada,"rad")){
		if(!strcmp(kategorija_rada,"m21"))return 4;
		else return 2;
	}
	else return 3;
	}else return 1;
}
void ucitaj(struct stablo**d,char*dat){
	int i,n;
	FILE*in=fopen(dat,"r");
		fscanf(in,"%d",&n);
		char s[150];
		for(i=0;i<n;i++){
			fgetc(in);
			struct stablo*temp=(struct stablo*)malloc(sizeof(struct stablo));
			temp->boja=CRVENA;
			temp->levi=temp->desni=temp->roditelj=NULL;
			fgets(s,150,in);
			strtok(s,"\n");
			temp->ime=(char*)malloc((strlen(s)+1)*sizeof(char));
			strcpy(temp->ime,s);
			fscanf(in,"%s",s);
			if(!strcmp(s,"rad")){
				char s2[6];
				fscanf(in,"%s",s2);	
				strcpy(temp->kategorija_rada,s2);
			}
			strcpy(temp->tip_rada,s);
			dodaj(d,temp);
		}
	fclose(in);
}
void brisi(struct stablo*d,struct stablo**novo){
	if(d){
		if(strcmp(d->tip_rada,"nema")){
			struct stablo*temp=(struct stablo*)malloc(sizeof(struct stablo));
			temp->boja=CRVENA;
			temp->levi=temp->desni=temp->roditelj;
			temp->ime=(char*)malloc((strlen(d->ime)+1)*sizeof(char));
			strcpy(temp->ime,d->ime);
			strcpy(temp->tip_rada,d->tip_rada);
			strcpy(temp->kategorija_rada,d->kategorija_rada);
			dodaj(novo,temp);
		}
		brisi(d->desni,novo);
		brisi(d->levi,novo);
	}
}
void ispis(struct stablo*d){
	if(d){
		ispis(d->desni);
		printf("Ime:%s Tip_rada:%s Kategorija_rada:%s boja=%d\n",d->ime,d->tip_rada,d->kategorija_rada,d->boja);
		ispis(d->levi);
	}
}
void mono_ili_naucni(int*mono,int*naucni,struct stablo*d){
	if(d){
		if(!strcmp(d->tip_rada,"monografija"))*mono=(*mono)+1;
		if((!strcmp(d->tip_rada,"rad")) &&(!strcmp(d->kategorija_rada,"m21")))(*naucni)=(*naucni)+1;
	mono_ili_naucni(mono,naucni,d->levi);
	mono_ili_naucni(mono,naucni,d->desni);
	}
}
main(int argc,char*argv[]){
	int monografija=0,naucni=0;
	struct stablo*d=NULL;
	struct stablo*novo=NULL;
	ucitaj(&d,argv[1]);
	ispis(d);
	brisi(d,&novo);
	printf("\n\n");
	ispis(novo);
	mono_ili_naucni(&monografija,&naucni,novo);	
	printf("\n\n");
	if(monografija>naucni)printf("Vise monografije\n");
	else {
			if(monografija==naucni)printf("Ima isto i monografije i naucnog u kategoriji m21\n");
			else
			printf("Vise naucnog u kategoriji m21\n");
		}
}
