#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{CRVENA,CRNA};
enum{monografija,rad,nema};
enum{M21,M22};
typedef struct drvo{
	int boja;
	char ime[2000];
	char TIP_RADA[5000];
	char KATEGORIJA_RADA[5000];
	struct drvo *levo,*desno,*roditelj;
}drvo;

#define novi(x) x=(drvo *)malloc(sizeof(drvo))

void lrotacija(drvo **p){
	drvo *x,*y;
	x=*p;
	y=x->desno;
	x->desno=y->levo;
	if(y->levo) y->levo->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj){
			if(x==x->roditelj->levo) x->roditelj->levo=y;
			else x->roditelj->desno=y;
		}
	x->roditelj=y;
	y->levo=x;
	*p=y;
}




void drotacija(drvo **p){
	drvo *x,*y;
	y=*p;
	x=y->levo;
	y->levo=x->desno;
	if(x->desno) x->desno->roditelj=y;
	x->roditelj=y->roditelj;
	if(y->roditelj){
			if(y==y->roditelj->levo) y->roditelj->levo=x;
			else y->roditelj->desno=x;
		}
	y->roditelj=x;
	x->desno=y;
	*p=x;
}
void bojefix(drvo **p,drvo *z){
	drvo *t,*y;
	while((z->roditelj) && (z->roditelj->boja==CRVENA)){
			if(z->roditelj==z->roditelj->roditelj->levo){
					y=z->roditelj->roditelj->desno;
					if((y) && (y->boja==CRVENA)){
							z->roditelj->boja=CRNA;
							t->boja=CRNA;
							t->roditelj->boja=CRVENA;
							z=z->roditelj->roditelj;
						}
						else{
								if(z==z->roditelj->desno){
										z=z->roditelj;
										lrotacija(&z);
										if(!z->roditelj) *p=z;
										z=z->levo;
									}
								t=z->roditelj->roditelj;
								z->roditelj->boja=CRNA;
								t->boja=CRVENA;
								drotacija(&t);
								if(!t->roditelj) *p=t;
							}
				}
			else{
					y=z->roditelj->roditelj->levo;
					if((y) && (y->boja==CRVENA)){
							z->roditelj->boja=CRNA;
							t->boja=CRNA;
							t->roditelj->boja=CRVENA;
							z=z->roditelj->roditelj;
						}
						else{
								if(z==z->roditelj->levo){
										z=z->roditelj;
										drotacija(&z);
										if(!z->roditelj) *p=z;
										z=z->desno;
									}
								t=z->roditelj->roditelj;
								z->roditelj->boja=CRNA;
								t->boja=CRVENA;
								lrotacija(&t);
								if(!t->roditelj) *p=t;
							}
				}
		}
	(*p)->boja=CRNA;
}
int poredi(drvo *s,drvo *p){
	int xk,yk,xt,yt;
	if(!strcmp(s->TIP_RADA,"rad")){
			if(!strcmp(s->KATEGORIJA_RADA,"M21"))
			{ xk=4;
			  xt=4;
			}
		}
		else if(!strcmp(s->TIP_RADA,"monografija")){
			 xt=3;
			 xk=3;
			}
		
		else if(!strcmp(s->TIP_RADA,"rad")){
			
					if(!strcmp(s->KATEGORIJA_RADA,"M22")){
						 xk=2;
						 xt=2;
						}
				}
		
		else if(!strcmp(s->TIP_RADA,"nema")) {
			xt=1;
			xk=1;
			}
		
		
	if(!strcmp(p->TIP_RADA,"rad")){
			if(!strcmp(p->KATEGORIJA_RADA,"M21"))
			{ yk=4;
			  yt=4;
			}
		}
		else if(!strcmp(p->TIP_RADA,"monografija")){
			 yt=3;
			 yk=3;
		 }
		
		else if(!strcmp(p->TIP_RADA,"rad")){
			
					if(!strcmp(p->KATEGORIJA_RADA,"M22")){
						 yk=2;
						 yt=2;
						}
				}
		
		else if(!strcmp(p->TIP_RADA,"nema")) {
			 yt=1;
			 yk=1;
		 }
		
		
		
		if(xt<yt) return -1;
		else if((xt==yt) || (xk==yk)) return 0;
			else return 0;	
}
void dodaj(drvo **p,drvo *z){
	drvo *x,*y;
	x=*p;
	y=NULL;
	while(x){
				y=x;
				if(poredi(z,x)==-1) x=x->levo;
				else x=x->desno;
			}
		z->roditelj=y;
		if(!y) *p=z;
		else{
				if(poredi(z,y)==-1) y->levo=z;
				else y->desno=z;
			}
	bojefix(p,z);
}

drvo *formiraj(){
	drvo *koren=NULL,*cvor;
	int i,n;
	printf("Unesi n ");
	scanf("%d",&n);
	for(i=0;i<n;i++){
			novi(cvor);
			cvor->levo=cvor->desno=NULL;
			printf("Unesi ime: ");
			scanf("%s",cvor->ime);
			printf("Unesi tip rada: ");
			scanf("%s",cvor->TIP_RADA);
			if(!strcmp(cvor->TIP_RADA,"rad")){
				printf("Unesi kategoriju: ");
					scanf("%s",cvor->KATEGORIJA_RADA);
				}
			cvor->boja=CRVENA;
			dodaj(&koren,cvor);
		}
	return koren;
}
void stampaj(drvo *p){
	if(p){
			stampaj(p->desno);
			printf("%s ",p->ime);
			printf("%s ",p->TIP_RADA);
			if(!strcmp(p->TIP_RADA,"rad")){
					printf("%s ",p->KATEGORIJA_RADA);
				}
			stampaj(p->levo);
		}
	printf("\n");
}
main(){
	drvo *koren;
	koren=formiraj();
	stampaj(koren);
}





























